diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/tcp-socket-base.cc ns-3.42/src/internet/model/tcp-socket-base.cc
--- ns-3.41/src/internet/model/tcp-socket-base.cc	2024-02-09 14:44:07.941790300 -0800
+++ ns-3.42/src/internet/model/tcp-socket-base.cc	2024-05-29 15:29:46.968073100 -0700
@@ -575,7 +575,6 @@
         InetSocketAddress transport = InetSocketAddress::ConvertFrom(address);
         Ipv4Address ipv4 = transport.GetIpv4();
         uint16_t port = transport.GetPort();
-        SetIpTos(transport.GetTos());
         if (ipv4 == Ipv4Address::GetAny() && port == 0)
         {
             m_endPoint = m_tcp->Allocate();
@@ -690,7 +689,6 @@
         }
         InetSocketAddress transport = InetSocketAddress::ConvertFrom(address);
         m_endPoint->SetPeer(transport.GetIpv4(), transport.GetPort());
-        SetIpTos(transport.GetTos());
         m_endPoint6 = nullptr;
 
         // Get the appropriate local address and port number from the routing protocol and set up
@@ -871,7 +869,7 @@
         if ((m_state == ESTABLISHED || m_state == CLOSE_WAIT) && AvailableWindow() > 0)
         { // Try to send the data out: Add a little step to allow the application
             // to fill the buffer
-            if (!m_sendPendingDataEvent.IsRunning())
+            if (!m_sendPendingDataEvent.IsPending())
             {
                 m_sendPendingDataEvent = Simulator::Schedule(TimeStep(1),
                                                              &TcpSocketBase::SendPendingData,
@@ -1138,7 +1136,7 @@
         NotifyNormalClose();
         m_closeNotified = true;
     }
-    if (m_lastAckEvent.IsRunning())
+    if (m_lastAckEvent.IsPending())
     {
         m_lastAckEvent.Cancel();
     }
@@ -1475,7 +1473,7 @@
         break;
     }
 
-    if (m_rWnd.Get() != 0 && m_persistEvent.IsRunning())
+    if (m_rWnd.Get() != 0 && m_persistEvent.IsPending())
     { // persist probes end, the other end has increased the window
         NS_ASSERT(m_connected);
         NS_LOG_LOGIC(this << " Leaving zerowindow persist state");
@@ -1538,13 +1536,13 @@
             ReceivedAck(packet, tcpHeader);
         }
     }
-    else if (tcpflags == TcpHeader::SYN)
-    { // Received SYN, old NS-3 behaviour is to set state to SYN_RCVD and
-      // respond with a SYN+ACK. But it is not a legal state transition as of
-      // RFC793. Thus this is ignored.
-    }
-    else if (tcpflags == (TcpHeader::SYN | TcpHeader::ACK))
-    { // No action for received SYN+ACK, it is probably a duplicated packet
+    else if (tcpflags == TcpHeader::SYN || tcpflags == (TcpHeader::SYN | TcpHeader::ACK))
+    {
+        // (a) Received SYN, old NS-3 behaviour is to set state to SYN_RCVD and
+        // respond with a SYN+ACK. But it is not a legal state transition as of
+        // RFC793. Thus this is ignored.
+
+        // (b) No action for received SYN+ACK, it is probably a duplicated packet
     }
     else if (tcpflags == TcpHeader::FIN || tcpflags == (TcpHeader::FIN | TcpHeader::ACK))
     { // Received FIN or FIN+ACK, bring down this socket nicely
@@ -3240,6 +3238,12 @@
                      << m_endPoint6->GetPeerAddress() << ". Header " << header);
     }
 
+    // Signal to congestion control whether the cwnd is fully used
+    // This is a simple version of Linux tcp_cwnd_validate() but following
+    // the principle implemented in Linux that limits the updating of cwnd
+    // (in the congestion controls) when flight size is >= cwnd
+    m_tcb->m_isCwndLimited = (BytesInFlight() >= m_tcb->m_cWnd);
+
     UpdateRttHistory(seq, sz, isRetransmission);
 
     // Update bytes sent during recovery phase
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/tcp-socket-state.cc ns-3.42/src/internet/model/tcp-socket-state.cc
--- ns-3.41/src/internet/model/tcp-socket-state.cc	2024-02-09 14:44:07.941790300 -0800
+++ ns-3.42/src/internet/model/tcp-socket-state.cc	2024-05-29 15:29:46.968073100 -0700
@@ -119,6 +119,7 @@
       m_paceInitialWindow(other.m_paceInitialWindow),
       m_minRtt(other.m_minRtt),
       m_bytesInFlight(other.m_bytesInFlight),
+      m_isCwndLimited(other.m_isCwndLimited),
       m_lastRtt(other.m_lastRtt),
       m_ecnMode(other.m_ecnMode),
       m_useEcn(other.m_useEcn),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/tcp-socket-state.h ns-3.42/src/internet/model/tcp-socket-state.h
--- ns-3.41/src/internet/model/tcp-socket-state.h	2024-02-09 14:44:07.941790300 -0800
+++ ns-3.42/src/internet/model/tcp-socket-state.h	2024-05-29 15:29:46.968073100 -0700
@@ -207,6 +207,7 @@
     Time m_minRtt{Time::Max()}; //!< Minimum RTT observed throughout the connection
 
     TracedValue<uint32_t> m_bytesInFlight{0};  //!< Bytes in flight
+    bool m_isCwndLimited{false};               //!< Whether throughput is limited by cwnd
     TracedValue<Time> m_lastRtt{Seconds(0.0)}; //!< Last RTT sample collected
 
     Ptr<TcpRxBuffer> m_rxBuffer; //!< Rx buffer (reordering buffer)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/tcp-tx-buffer.cc ns-3.42/src/internet/model/tcp-tx-buffer.cc
--- ns-3.41/src/internet/model/tcp-tx-buffer.cc	2024-02-09 14:44:07.941790300 -0800
+++ ns-3.42/src/internet/model/tcp-tx-buffer.cc	2024-05-29 15:29:46.968073100 -0700
@@ -866,8 +866,8 @@
 
     NS_ASSERT((*(m_sentList.begin()))->m_sacked == false);
     NS_ASSERT_MSG(m_sentSize >= m_sackedOut + m_lostOut, *this);
-    // NS_ASSERT (list.size () == 0 || modified);   // Assert for duplicated SACK or
-    //  impossiblity to map the option into the sent blocks
+    // Assert for duplicated SACK or impossibility to map the option into the sent blocks
+    // NS_ASSERT (list.size () == 0 || modified);
     ConsistencyCheck();
     return bytesSacked;
 }
@@ -1103,14 +1103,10 @@
         {
             bool isLost = IsLostRFC(beginOfCurrentPkt, it);
             // (a) If IsLost (S1) returns false: Pipe is incremented by 1 octet.
-            if (!isLost)
-            {
-                size += item->m_packet->GetSize();
-            }
             // (b) If S1 <= HighRxt: Pipe is incremented by 1 octet.
             // (NOTE: we use the m_retrans flag instead of keeping and updating
             // another variable). Only if the item is not marked as lost
-            else if (item->m_retrans)
+            if (!isLost || item->m_retrans)
             {
                 size += item->m_packet->GetSize();
             }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/udp-header.cc ns-3.42/src/internet/model/udp-header.cc
--- ns-3.41/src/internet/model/udp-header.cc	2024-02-09 14:44:07.945790300 -0800
+++ ns-3.42/src/internet/model/udp-header.cc	2024-05-29 15:29:46.968073100 -0700
@@ -189,6 +189,12 @@
 
             i = start;
             i.Next(6);
+
+            // RFC 768: If the computed checksum is zero, it is transmitted as all ones
+            if (checksum == 0)
+            {
+                checksum = 0xffff;
+            }
             i.WriteU16(checksum);
         }
     }
@@ -207,7 +213,24 @@
     m_payloadSize = i.ReadNtohU16() - GetSerializedSize();
     m_checksum = i.ReadU16();
 
-    if (m_calcChecksum)
+    // RFC 768: An all zero transmitted checksum value means that the
+    // transmitter generated  no checksum (for debugging or for higher
+    // level protocols that don't care).
+    //
+    // This is common in IPv4, while IPv6 requires UDP to use its checksum.
+    //
+    // As strange as it might sound, flipping from 0x0000 to 0xffff does not
+    // change anything in the verification.
+    //
+    // According to RFC 1141, the following holds:
+    // ~C' = ~(C + (-m) + m') = ~C + (m - m') = ~C + m + ~m'
+    // If ~C (the original CRC) is zero, m (the CRC field) is zero, and m' is 0xffff,
+    // then, according to the formula, we have that ~C' is zero.
+    // I.e., changing the CRC from 0 to 0xffff has no effect on the Rx verification.
+    //
+    // Fun fact: if you take an IPv4 header with an Identification field set to zero
+    // and you change it to 0xffff, the checksum will not change (~_^)
+    if (m_calcChecksum && m_checksum)
     {
         uint16_t headerChecksum = CalculateHeaderChecksum(start.GetSize());
         i = start;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/model/udp-socket-impl.cc ns-3.42/src/internet/model/udp-socket-impl.cc
--- ns-3.41/src/internet/model/udp-socket-impl.cc	2024-02-09 14:44:07.945790300 -0800
+++ ns-3.42/src/internet/model/udp-socket-impl.cc	2024-05-29 15:29:46.968073100 -0700
@@ -280,7 +280,6 @@
         InetSocketAddress transport = InetSocketAddress::ConvertFrom(address);
         Ipv4Address ipv4 = transport.GetIpv4();
         uint16_t port = transport.GetPort();
-        SetIpTos(transport.GetTos());
         if (ipv4 == Ipv4Address::GetAny() && port == 0)
         {
             m_endPoint = m_udp->Allocate();
@@ -416,7 +415,6 @@
         InetSocketAddress transport = InetSocketAddress::ConvertFrom(address);
         m_defaultAddress = Address(transport.GetIpv4());
         m_defaultPort = transport.GetPort();
-        SetIpTos(transport.GetTos());
         m_connected = true;
         NotifyConnectionSucceeded();
     }
@@ -839,8 +837,7 @@
         InetSocketAddress transport = InetSocketAddress::ConvertFrom(address);
         Ipv4Address ipv4 = transport.GetIpv4();
         uint16_t port = transport.GetPort();
-        uint8_t tos = transport.GetTos();
-        return DoSendTo(p, ipv4, port, tos);
+        return DoSendTo(p, ipv4, port, GetIpTos());
     }
     else if (Inet6SocketAddress::IsMatchingType(address))
     {
@@ -931,9 +928,7 @@
     if (Ipv4Address::IsMatchingType(m_defaultAddress))
     {
         Ipv4Address addr = Ipv4Address::ConvertFrom(m_defaultAddress);
-        InetSocketAddress inet(addr, m_defaultPort);
-        inet.SetTos(GetIpTos());
-        address = inet;
+        address = InetSocketAddress(addr, m_defaultPort);
     }
     else if (Ipv6Address::IsMatchingType(m_defaultAddress))
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/global-route-manager-impl-test-suite.cc ns-3.42/src/internet/test/global-route-manager-impl-test-suite.cc
--- ns-3.41/src/internet/test/global-route-manager-impl-test-suite.cc	2024-02-09 14:44:07.945790300 -0800
+++ ns-3.42/src/internet/test/global-route-manager-impl-test-suite.cc	2024-05-29 15:29:46.968073100 -0700
@@ -229,9 +229,9 @@
 };
 
 GlobalRouteManagerImplTestSuite::GlobalRouteManagerImplTestSuite()
-    : TestSuite("global-route-manager-impl", UNIT)
+    : TestSuite("global-route-manager-impl", Type::UNIT)
 {
-    AddTestCase(new GlobalRouteManagerImplTestCase(), TestCase::QUICK);
+    AddTestCase(new GlobalRouteManagerImplTestCase(), TestCase::Duration::QUICK);
 }
 
 static GlobalRouteManagerImplTestSuite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/icmp-test.cc ns-3.42/src/internet/test/icmp-test.cc
--- ns-3.41/src/internet/test/icmp-test.cc	2024-02-09 14:44:07.945790300 -0800
+++ ns-3.42/src/internet/test/icmp-test.cc	2024-05-29 15:29:46.968073100 -0700
@@ -664,12 +664,12 @@
 };
 
 IcmpTestSuite::IcmpTestSuite()
-    : TestSuite("icmp", UNIT)
+    : TestSuite("icmp", Type::UNIT)
 {
-    AddTestCase(new IcmpEchoReplyTestCase, TestCase::QUICK);
-    AddTestCase(new IcmpTimeExceedTestCase, TestCase::QUICK);
-    AddTestCase(new IcmpV6EchoReplyTestCase, TestCase::QUICK);
-    AddTestCase(new IcmpV6TimeExceedTestCase, TestCase::QUICK);
+    AddTestCase(new IcmpEchoReplyTestCase, TestCase::Duration::QUICK);
+    AddTestCase(new IcmpTimeExceedTestCase, TestCase::Duration::QUICK);
+    AddTestCase(new IcmpV6EchoReplyTestCase, TestCase::Duration::QUICK);
+    AddTestCase(new IcmpV6TimeExceedTestCase, TestCase::Duration::QUICK);
 }
 
 static IcmpTestSuite icmpTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/internet-stack-helper-test-suite.cc ns-3.42/src/internet/test/internet-stack-helper-test-suite.cc
--- ns-3.41/src/internet/test/internet-stack-helper-test-suite.cc	2024-02-09 14:44:07.945790300 -0800
+++ ns-3.42/src/internet/test/internet-stack-helper-test-suite.cc	2024-05-29 15:29:46.968073100 -0700
@@ -148,9 +148,9 @@
 {
   public:
     InternetStackHelperTestSuite()
-        : TestSuite("internet-stack-helper", UNIT)
+        : TestSuite("internet-stack-helper", Type::UNIT)
     {
-        AddTestCase(new InternetStackHelperTestCase(), TestCase::QUICK);
+        AddTestCase(new InternetStackHelperTestCase(), TestCase::Duration::QUICK);
     }
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/ipv4-address-generator-test-suite.cc ns-3.42/src/internet/test/ipv4-address-generator-test-suite.cc
--- ns-3.41/src/internet/test/ipv4-address-generator-test-suite.cc	2024-02-09 14:44:07.945790300 -0800
+++ ns-3.42/src/internet/test/ipv4-address-generator-test-suite.cc	2024-05-29 15:29:46.968073100 -0700
@@ -363,13 +363,13 @@
 };
 
 Ipv4AddressGeneratorTestSuite::Ipv4AddressGeneratorTestSuite()
-    : TestSuite("ipv4-address-generator", UNIT)
+    : TestSuite("ipv4-address-generator", Type::UNIT)
 {
-    AddTestCase(new NetworkNumberAllocatorTestCase(), TestCase::QUICK);
-    AddTestCase(new AddressAllocatorTestCase(), TestCase::QUICK);
-    AddTestCase(new NetworkAndAddressTestCase(), TestCase::QUICK);
-    AddTestCase(new ExampleAddressGeneratorTestCase(), TestCase::QUICK);
-    AddTestCase(new AddressCollisionTestCase(), TestCase::QUICK);
+    AddTestCase(new NetworkNumberAllocatorTestCase(), TestCase::Duration::QUICK);
+    AddTestCase(new AddressAllocatorTestCase(), TestCase::Duration::QUICK);
+    AddTestCase(new NetworkAndAddressTestCase(), TestCase::Duration::QUICK);
+    AddTestCase(new ExampleAddressGeneratorTestCase(), TestCase::Duration::QUICK);
+    AddTestCase(new AddressCollisionTestCase(), TestCase::Duration::QUICK);
 }
 
 static Ipv4AddressGeneratorTestSuite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/ipv4-address-helper-test-suite.cc ns-3.42/src/internet/test/ipv4-address-helper-test-suite.cc
--- ns-3.41/src/internet/test/ipv4-address-helper-test-suite.cc	2024-02-09 14:44:07.945790300 -0800
+++ ns-3.42/src/internet/test/ipv4-address-helper-test-suite.cc	2024-05-29 15:29:46.968073100 -0700
@@ -289,12 +289,12 @@
 };
 
 Ipv4AddressHelperTestSuite::Ipv4AddressHelperTestSuite()
-    : TestSuite("ipv4-address-helper", UNIT)
+    : TestSuite("ipv4-address-helper", Type::UNIT)
 {
-    AddTestCase(new NetworkAllocatorHelperTestCase(), TestCase::QUICK);
-    AddTestCase(new AddressAllocatorHelperTestCase(), TestCase::QUICK);
-    AddTestCase(new ResetAllocatorHelperTestCase(), TestCase::QUICK);
-    AddTestCase(new IpAddressHelperTestCasev4(), TestCase::QUICK);
+    AddTestCase(new NetworkAllocatorHelperTestCase(), TestCase::Duration::QUICK);
+    AddTestCase(new AddressAllocatorHelperTestCase(), TestCase::Duration::QUICK);
+    AddTestCase(new ResetAllocatorHelperTestCase(), TestCase::Duration::QUICK);
+    AddTestCase(new IpAddressHelperTestCasev4(), TestCase::Duration::QUICK);
 }
 
 static Ipv4AddressHelperTestSuite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/ipv4-deduplication-test.cc ns-3.42/src/internet/test/ipv4-deduplication-test.cc
--- ns-3.41/src/internet/test/ipv4-deduplication-test.cc	2024-02-09 14:44:07.945790300 -0800
+++ ns-3.42/src/internet/test/ipv4-deduplication-test.cc	2024-05-29 15:29:46.968073100 -0700
@@ -557,12 +557,12 @@
 };
 
 Ipv4DeduplicationTestSuite::Ipv4DeduplicationTestSuite()
-    : TestSuite("ipv4-deduplication", UNIT)
+    : TestSuite("ipv4-deduplication", Type::UNIT)
 {
-    AddTestCase(new Ipv4DeduplicationTest(true), TestCase::QUICK);
-    AddTestCase(new Ipv4DeduplicationTest(false), TestCase::QUICK);
+    AddTestCase(new Ipv4DeduplicationTest(true), TestCase::Duration::QUICK);
+    AddTestCase(new Ipv4DeduplicationTest(false), TestCase::Duration::QUICK);
     // degenerate case is enabled RFC but with too short an expiry
-    AddTestCase(new Ipv4DeduplicationTest(true, MicroSeconds(50)), TestCase::QUICK);
+    AddTestCase(new Ipv4DeduplicationTest(true, MicroSeconds(50)), TestCase::Duration::QUICK);
 }
 
 static Ipv4DeduplicationTestSuite
@@ -737,9 +737,9 @@
 };
 
 Ipv4DeduplicationPerformanceTestSuite::Ipv4DeduplicationPerformanceTestSuite()
-    : TestSuite("ipv4-deduplication-performance", PERFORMANCE)
+    : TestSuite("ipv4-deduplication-performance", Type::PERFORMANCE)
 {
-    AddTestCase(new Ipv4DeduplicationPerformanceTest, TestCase::EXTENSIVE);
+    AddTestCase(new Ipv4DeduplicationPerformanceTest, TestCase::Duration::EXTENSIVE);
 }
 
 static Ipv4DeduplicationPerformanceTestSuite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/ipv4-forwarding-test.cc ns-3.42/src/internet/test/ipv4-forwarding-test.cc
--- ns-3.41/src/internet/test/ipv4-forwarding-test.cc	2024-02-09 14:44:07.945790300 -0800
+++ ns-3.42/src/internet/test/ipv4-forwarding-test.cc	2024-05-29 15:29:46.968073100 -0700
@@ -238,9 +238,9 @@
 };
 
 Ipv4ForwardingTestSuite::Ipv4ForwardingTestSuite()
-    : TestSuite("ipv4-forwarding", UNIT)
+    : TestSuite("ipv4-forwarding", Type::UNIT)
 {
-    AddTestCase(new Ipv4ForwardingTest, TestCase::QUICK);
+    AddTestCase(new Ipv4ForwardingTest, TestCase::Duration::QUICK);
 }
 
 static Ipv4ForwardingTestSuite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/ipv4-fragmentation-test.cc ns-3.42/src/internet/test/ipv4-fragmentation-test.cc
--- ns-3.41/src/internet/test/ipv4-fragmentation-test.cc	2024-02-09 14:44:07.945790300 -0800
+++ ns-3.42/src/internet/test/ipv4-fragmentation-test.cc	2024-05-29 15:29:46.968073100 -0700
@@ -587,10 +587,10 @@
 };
 
 Ipv4FragmentationTestSuite::Ipv4FragmentationTestSuite()
-    : TestSuite("ipv4-fragmentation", UNIT)
+    : TestSuite("ipv4-fragmentation", Type::UNIT)
 {
-    AddTestCase(new Ipv4FragmentationTest(false), TestCase::QUICK);
-    AddTestCase(new Ipv4FragmentationTest(true), TestCase::QUICK);
+    AddTestCase(new Ipv4FragmentationTest(false), TestCase::Duration::QUICK);
+    AddTestCase(new Ipv4FragmentationTest(true), TestCase::Duration::QUICK);
 }
 
 static Ipv4FragmentationTestSuite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/ipv4-global-routing-test-suite.cc ns-3.42/src/internet/test/ipv4-global-routing-test-suite.cc
--- ns-3.41/src/internet/test/ipv4-global-routing-test-suite.cc	2024-02-09 14:44:07.945790300 -0800
+++ ns-3.42/src/internet/test/ipv4-global-routing-test-suite.cc	2024-05-29 15:29:46.968073100 -0700
@@ -1323,16 +1323,16 @@
 };
 
 Ipv4GlobalRoutingTestSuite::Ipv4GlobalRoutingTestSuite()
-    : TestSuite("ipv4-global-routing", UNIT)
+    : TestSuite("ipv4-global-routing", Type::UNIT)
 {
-    AddTestCase(new LinkTest, TestCase::QUICK);
-    AddTestCase(new LanTest, TestCase::QUICK);
-    AddTestCase(new TwoLinkTest, TestCase::QUICK);
-    AddTestCase(new TwoLanTest, TestCase::QUICK);
-    AddTestCase(new BridgeTest, TestCase::QUICK);
-    AddTestCase(new TwoBridgeTest, TestCase::QUICK);
-    AddTestCase(new Ipv4DynamicGlobalRoutingTestCase, TestCase::QUICK);
-    AddTestCase(new Ipv4GlobalRoutingSlash32TestCase, TestCase::QUICK);
+    AddTestCase(new LinkTest, TestCase::Duration::QUICK);
+    AddTestCase(new LanTest, TestCase::Duration::QUICK);
+    AddTestCase(new TwoLinkTest, TestCase::Duration::QUICK);
+    AddTestCase(new TwoLanTest, TestCase::Duration::QUICK);
+    AddTestCase(new BridgeTest, TestCase::Duration::QUICK);
+    AddTestCase(new TwoBridgeTest, TestCase::Duration::QUICK);
+    AddTestCase(new Ipv4DynamicGlobalRoutingTestCase, TestCase::Duration::QUICK);
+    AddTestCase(new Ipv4GlobalRoutingSlash32TestCase, TestCase::Duration::QUICK);
 }
 
 static Ipv4GlobalRoutingTestSuite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/ipv4-header-test.cc ns-3.42/src/internet/test/ipv4-header-test.cc
--- ns-3.41/src/internet/test/ipv4-header-test.cc	2024-02-09 14:44:07.945790300 -0800
+++ ns-3.42/src/internet/test/ipv4-header-test.cc	2024-05-29 15:29:46.968073100 -0700
@@ -299,9 +299,9 @@
 {
   public:
     Ipv4HeaderTestSuite()
-        : TestSuite("ipv4-header", UNIT)
+        : TestSuite("ipv4-header", Type::UNIT)
     {
-        AddTestCase(new Ipv4HeaderTest, TestCase::QUICK);
+        AddTestCase(new Ipv4HeaderTest, TestCase::Duration::QUICK);
     }
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/ipv4-list-routing-test-suite.cc ns-3.42/src/internet/test/ipv4-list-routing-test-suite.cc
--- ns-3.41/src/internet/test/ipv4-list-routing-test-suite.cc	2024-02-09 14:44:07.945790300 -0800
+++ ns-3.42/src/internet/test/ipv4-list-routing-test-suite.cc	2024-05-29 15:29:46.968073100 -0700
@@ -209,10 +209,10 @@
 {
   public:
     Ipv4ListRoutingTestSuite()
-        : TestSuite("ipv4-list-routing", UNIT)
+        : TestSuite("ipv4-list-routing", Type::UNIT)
     {
-        AddTestCase(new Ipv4ListRoutingPositiveTestCase(), TestCase::QUICK);
-        AddTestCase(new Ipv4ListRoutingNegativeTestCase(), TestCase::QUICK);
+        AddTestCase(new Ipv4ListRoutingPositiveTestCase(), TestCase::Duration::QUICK);
+        AddTestCase(new Ipv4ListRoutingNegativeTestCase(), TestCase::Duration::QUICK);
     }
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/ipv4-packet-info-tag-test-suite.cc ns-3.42/src/internet/test/ipv4-packet-info-tag-test-suite.cc
--- ns-3.41/src/internet/test/ipv4-packet-info-tag-test-suite.cc	2024-02-09 14:44:07.945790300 -0800
+++ ns-3.42/src/internet/test/ipv4-packet-info-tag-test-suite.cc	2024-05-29 15:29:46.968073100 -0700
@@ -220,9 +220,9 @@
 };
 
 Ipv4PacketInfoTagTestSuite::Ipv4PacketInfoTagTestSuite()
-    : TestSuite("ipv4-packet-info-tag", UNIT)
+    : TestSuite("ipv4-packet-info-tag", Type::UNIT)
 {
-    AddTestCase(new Ipv4PacketInfoTagTest(), TestCase::QUICK);
+    AddTestCase(new Ipv4PacketInfoTagTest(), TestCase::Duration::QUICK);
 }
 
 static Ipv4PacketInfoTagTestSuite g_packetinfotagTests; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/ipv4-raw-test.cc ns-3.42/src/internet/test/ipv4-raw-test.cc
--- ns-3.41/src/internet/test/ipv4-raw-test.cc	2024-02-09 14:44:07.945790300 -0800
+++ ns-3.42/src/internet/test/ipv4-raw-test.cc	2024-05-29 15:29:46.968073100 -0700
@@ -378,9 +378,9 @@
 {
   public:
     Ipv4RawTestSuite()
-        : TestSuite("ipv4-raw", UNIT)
+        : TestSuite("ipv4-raw", Type::UNIT)
     {
-        AddTestCase(new Ipv4RawSocketImplTest, TestCase::QUICK);
+        AddTestCase(new Ipv4RawSocketImplTest, TestCase::Duration::QUICK);
     }
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/ipv4-rip-test.cc ns-3.42/src/internet/test/ipv4-rip-test.cc
--- ns-3.41/src/internet/test/ipv4-rip-test.cc	2024-02-09 14:44:07.945790300 -0800
+++ ns-3.42/src/internet/test/ipv4-rip-test.cc	2024-05-29 15:29:46.968073100 -0700
@@ -703,13 +703,16 @@
 {
   public:
     Ipv4RipTestSuite()
-        : TestSuite("ipv4-rip", UNIT)
+        : TestSuite("ipv4-rip", Type::UNIT)
     {
-        AddTestCase(new Ipv4RipTest, TestCase::QUICK);
-        AddTestCase(new Ipv4RipCountToInfinityTest, TestCase::QUICK);
-        AddTestCase(new Ipv4RipSplitHorizonStrategyTest(Rip::POISON_REVERSE), TestCase::QUICK);
-        AddTestCase(new Ipv4RipSplitHorizonStrategyTest(Rip::SPLIT_HORIZON), TestCase::QUICK);
-        AddTestCase(new Ipv4RipSplitHorizonStrategyTest(Rip::NO_SPLIT_HORIZON), TestCase::QUICK);
+        AddTestCase(new Ipv4RipTest, TestCase::Duration::QUICK);
+        AddTestCase(new Ipv4RipCountToInfinityTest, TestCase::Duration::QUICK);
+        AddTestCase(new Ipv4RipSplitHorizonStrategyTest(Rip::POISON_REVERSE),
+                    TestCase::Duration::QUICK);
+        AddTestCase(new Ipv4RipSplitHorizonStrategyTest(Rip::SPLIT_HORIZON),
+                    TestCase::Duration::QUICK);
+        AddTestCase(new Ipv4RipSplitHorizonStrategyTest(Rip::NO_SPLIT_HORIZON),
+                    TestCase::Duration::QUICK);
     }
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/ipv4-static-routing-test-suite.cc ns-3.42/src/internet/test/ipv4-static-routing-test-suite.cc
--- ns-3.41/src/internet/test/ipv4-static-routing-test-suite.cc	2024-02-09 14:44:07.945790300 -0800
+++ ns-3.42/src/internet/test/ipv4-static-routing-test-suite.cc	2024-05-29 15:29:46.972073300 -0700
@@ -219,9 +219,9 @@
 };
 
 Ipv4StaticRoutingTestSuite::Ipv4StaticRoutingTestSuite()
-    : TestSuite("ipv4-static-routing", UNIT)
+    : TestSuite("ipv4-static-routing", Type::UNIT)
 {
-    AddTestCase(new Ipv4StaticRoutingSlash32TestCase, TestCase::QUICK);
+    AddTestCase(new Ipv4StaticRoutingSlash32TestCase, TestCase::Duration::QUICK);
 }
 
 static Ipv4StaticRoutingTestSuite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/ipv4-test.cc ns-3.42/src/internet/test/ipv4-test.cc
--- ns-3.41/src/internet/test/ipv4-test.cc	2024-02-09 14:44:07.945790300 -0800
+++ ns-3.42/src/internet/test/ipv4-test.cc	2024-05-29 15:29:46.972073300 -0700
@@ -129,9 +129,9 @@
 {
   public:
     IPv4L3ProtocolTestSuite()
-        : TestSuite("ipv4-protocol", UNIT)
+        : TestSuite("ipv4-protocol", Type::UNIT)
     {
-        AddTestCase(new Ipv4L3ProtocolTestCase(), TestCase::QUICK);
+        AddTestCase(new Ipv4L3ProtocolTestCase(), TestCase::Duration::QUICK);
     }
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/ipv6-address-duplication-test.cc ns-3.42/src/internet/test/ipv6-address-duplication-test.cc
--- ns-3.41/src/internet/test/ipv6-address-duplication-test.cc	2024-02-09 14:44:07.945790300 -0800
+++ ns-3.42/src/internet/test/ipv6-address-duplication-test.cc	2024-05-29 15:29:46.972073300 -0700
@@ -124,9 +124,9 @@
 {
   public:
     Ipv6DadTestSuite()
-        : TestSuite("ipv6-duplicate-address-detection", UNIT)
+        : TestSuite("ipv6-duplicate-address-detection", Type::UNIT)
     {
-        AddTestCase(new Ipv6DadTest, TestCase::QUICK);
+        AddTestCase(new Ipv6DadTest, TestCase::Duration::QUICK);
     }
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/ipv6-address-generator-test-suite.cc ns-3.42/src/internet/test/ipv6-address-generator-test-suite.cc
--- ns-3.41/src/internet/test/ipv6-address-generator-test-suite.cc	2024-02-09 14:44:07.945790300 -0800
+++ ns-3.42/src/internet/test/ipv6-address-generator-test-suite.cc	2024-05-29 15:29:46.972073300 -0700
@@ -352,11 +352,11 @@
     Ipv6AddressGeneratorTestSuite()
         : TestSuite("ipv6-address-generator")
     {
-        AddTestCase(new NetworkNumber6AllocatorTestCase(), TestCase::QUICK);
-        AddTestCase(new AddressAllocator6TestCase(), TestCase::QUICK);
-        AddTestCase(new NetworkAndAddress6TestCase(), TestCase::QUICK);
-        AddTestCase(new ExampleAddress6GeneratorTestCase(), TestCase::QUICK);
-        AddTestCase(new AddressCollision6TestCase(), TestCase::QUICK);
+        AddTestCase(new NetworkNumber6AllocatorTestCase(), TestCase::Duration::QUICK);
+        AddTestCase(new AddressAllocator6TestCase(), TestCase::Duration::QUICK);
+        AddTestCase(new NetworkAndAddress6TestCase(), TestCase::Duration::QUICK);
+        AddTestCase(new ExampleAddress6GeneratorTestCase(), TestCase::Duration::QUICK);
+        AddTestCase(new AddressCollision6TestCase(), TestCase::Duration::QUICK);
     }
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/ipv6-address-helper-test-suite.cc ns-3.42/src/internet/test/ipv6-address-helper-test-suite.cc
--- ns-3.41/src/internet/test/ipv6-address-helper-test-suite.cc	2024-02-09 14:44:07.945790300 -0800
+++ ns-3.42/src/internet/test/ipv6-address-helper-test-suite.cc	2024-05-29 15:29:46.972073300 -0700
@@ -179,9 +179,9 @@
 };
 
 Ipv6AddressHelperTestSuite::Ipv6AddressHelperTestSuite()
-    : TestSuite("ipv6-address-helper", UNIT)
+    : TestSuite("ipv6-address-helper", Type::UNIT)
 {
-    AddTestCase(new IpAddressHelperTestCasev6, TestCase::QUICK);
+    AddTestCase(new IpAddressHelperTestCasev6, TestCase::Duration::QUICK);
 }
 
 static Ipv6AddressHelperTestSuite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/ipv6-dual-stack-test-suite.cc ns-3.42/src/internet/test/ipv6-dual-stack-test-suite.cc
--- ns-3.41/src/internet/test/ipv6-dual-stack-test-suite.cc	2024-02-09 14:44:07.945790300 -0800
+++ ns-3.42/src/internet/test/ipv6-dual-stack-test-suite.cc	2024-05-29 15:29:46.972073300 -0700
@@ -360,9 +360,9 @@
 {
   public:
     Ipv6DualStackTestSuite()
-        : TestSuite("ipv6-dual-stack", UNIT)
+        : TestSuite("ipv6-dual-stack", Type::UNIT)
     {
-        AddTestCase(new DualStackTestCase(), TestCase::QUICK);
+        AddTestCase(new DualStackTestCase(), TestCase::Duration::QUICK);
     }
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/ipv6-extension-header-test-suite.cc ns-3.42/src/internet/test/ipv6-extension-header-test-suite.cc
--- ns-3.41/src/internet/test/ipv6-extension-header-test-suite.cc	2024-02-09 14:44:07.945790300 -0800
+++ ns-3.42/src/internet/test/ipv6-extension-header-test-suite.cc	2024-05-29 15:29:46.972073300 -0700
@@ -170,7 +170,7 @@
 
     Alignment GetAlignment() const override
     {
-        return (Alignment){4, 0};
+        return Alignment{4, 0};
     }
 };
 
@@ -279,12 +279,12 @@
 {
   public:
     Ipv6ExtensionHeaderTestSuite()
-        : TestSuite("ipv6-extension-header", UNIT)
+        : TestSuite("ipv6-extension-header", Type::UNIT)
     {
-        AddTestCase(new TestEmptyOptionField, TestCase::QUICK);
-        AddTestCase(new TestOptionWithoutAlignment, TestCase::QUICK);
-        AddTestCase(new TestOptionWithAlignment, TestCase::QUICK);
-        AddTestCase(new TestFulfilledAlignment, TestCase::QUICK);
+        AddTestCase(new TestEmptyOptionField, TestCase::Duration::QUICK);
+        AddTestCase(new TestOptionWithoutAlignment, TestCase::Duration::QUICK);
+        AddTestCase(new TestOptionWithAlignment, TestCase::Duration::QUICK);
+        AddTestCase(new TestFulfilledAlignment, TestCase::Duration::QUICK);
     }
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/ipv6-forwarding-test.cc ns-3.42/src/internet/test/ipv6-forwarding-test.cc
--- ns-3.41/src/internet/test/ipv6-forwarding-test.cc	2024-02-09 14:44:07.945790300 -0800
+++ ns-3.42/src/internet/test/ipv6-forwarding-test.cc	2024-05-29 15:29:46.972073300 -0700
@@ -218,9 +218,9 @@
 {
   public:
     Ipv6ForwardingTestSuite()
-        : TestSuite("ipv6-forwarding", UNIT)
+        : TestSuite("ipv6-forwarding", Type::UNIT)
     {
-        AddTestCase(new Ipv6ForwardingTest, TestCase::QUICK);
+        AddTestCase(new Ipv6ForwardingTest, TestCase::Duration::QUICK);
     }
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet/test/ipv6-fragmentation-test.cc ns-3.42/src/internet/test/ipv6-fragmentation-test.cc
--- ns-3.41/src/internet/test/ipv6-fragmentation-test.cc	2024-02-09 14:44:07.945790300 -0800
+++ ns-3.42/src/internet/test/ipv6-fragmentation-test.cc	2024-05-29 15:29:46.972073300 -0700
@@ -623,9 +623,9 @@
 {
   public:
     Ipv6FragmentationTestSuite()
-        : TestSuite("ipv6-fragmentation", UNIT)
+        : TestSuite("ipv6-fragmentation", Type::UNIT)
     {
-        AddTestCase(new Ipv6FragmentationTest, TestCase::QUICK);
+        AddTestCase(new Ipv6FragmentationTest, TestCase::Duration::QUICK);
     }
 };
 
